#ifndef STRCAST_H_
#define STRCAST_H_

#include <tchar.h>
#include <ole2.h>

#ifdef _UNICODE
#ifndef UNICODE
#define UNICODE 1
#endif
#endif

// TCHAR is char or wchar_t
#undef T2C
#undef T2W
#ifdef UNICODE
#define T2C(ts, cs, l) WideCharToMultiByte(CP_ACP, 0, ts, -1, cs, l, NULL, NULL)
#define T2W(ts, ws, l) wcsncpy(os, ws, l)
#else
#define T2C(ts, cs, l) strncpy(cs, ts, l)
#define T2W(ts, ws, l) MultiByteToWideChar(CP_ACP, 0, ts, -1, ws, l); 
#endif

// wchar is ... wchar
#undef W2T
#undef W2C
#ifdef UNICODE
#define W2T(ws, ts, l) wcsncpy(ts, ws, l)
#else
#define W2T(ws, ts, l) WideCharToMultiByte(CP_ACP, 0, ws, -1, ts, l, NULL, NULL)
#endif
#define W2C(ws, cs, l) WideCharToMultiByte(CP_ACP, 0, ws, -1, cs, l, NULL, NULL)

// char is char
#undef C2W
#undef C2T
#define C2W(cs, ws, l) MultiByteToWideChar(CP_ACP, 0, cs, -1, ws, l)
#ifdef UNICODE
#define C2T(cs, ts, l) C2W(cs, ts, l)
#else
#define C2T(cs, ts, l) strncpy(ts, cs, l)
#endif

#endif
